image: docker:19.03.13-dind
stages:
  - build
  - deploy

build_image:
  stage: build
  tags: 
    - chk-docker
  services:
    - docker:19.03.13-dind
  variables:
    IMAGE_TAG: calvin.ho:chat-backend
    DOCKER_TLS_CERTDIR: ""
  script:
    - echo -e "ACCOUNTSID=$ACCOUNTSID\nAUTHTOKEN=$AUTHTOKEN\nDB_HOST=$DB_HOST\nDB_USER=$DB_USER\nDB_PASSWORD=$DB_PASSWORD\nDB_PORT=$DB_PORT" >> .env
    - export BUILD_ARGS=$(for arg in $(cat .env); do echo "--build-arg $arg ";done | tr -d '\n');
    - docker login -u $CI_REGISTRY_USER_DOCKER -p $CI_REGISTRY_PASSWORD_DOCKER $CI_REGISTRY 
    - docker build -t $CI_REGISTRY/calvin.ho/chat-backend $BUILD_ARGS .
    - docker push $CI_REGISTRY/calvin.ho/chat-backend
  
deploy:
  stage: deploy
  tags: 
    - chk-docker
  services:
    - docker:19.03.13-dind
  script:
    - apk add --no-cache rsync openssh sshpass
    - mkdir -p ~/.ssh
    - echo "$SSH_PRIVATE_KEY" >> ~/.ssh/id_dsa
    - chmod 600 ~/.ssh/id_dsa
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    - sshpass -p ${SSH_PK_PW} ssh ${SSH_HOSTNAME} "docker pull $CI_REGISTRY/calvin.ho/chat-backend && docker stop node-backend && docker rm node-backend && docker run -d --name node-backend -p 5000:5000 $CI_REGISTRY/calvin.ho/chat-backend"